<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd"><html xmlns="http://www.w3.org/1999/xhtml"><head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.20"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<a class="dashingAutolink" name="autolink-3"></a><a class="dashAnchor" name="//apple_ref/cpp/Package/XHXKit%3A%20%2FUsers%2Fscar1900%2FDeveloper%2FXHXKit%2FXHXKit%2FClasses%2FBMDragCellCollectionView%2FBMDragCellCollectionView.m%20%E6%BA%90%E6%96%87%E4%BB%B6"></a><title>XHXKit: /Users/scar1900/Developer/XHXKit/XHXKit/Classes/BMDragCellCollectionView/BMDragCellCollectionView.m 源文件</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css"/>
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">XHXKit
   &nbsp;<span id="projectnumber">4.10.0.12</span>
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- 制作者 Doxygen 1.8.20 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'搜索');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','搜索');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow" onmouseover="return searchBox.OnSearchSelectShow()" onmouseout="return searchBox.OnSearchSelectHide()" onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_d522931ffa1371640980b621734a4381.html">Users</a></li><li class="navelem"><a class="el" href="dir_2f48480e0fdb0436fb8fd57a1ed5f613.html">scar1900</a></li><li class="navelem"><a class="el" href="dir_c8b33409012acfc781ba898892fd3b4c.html">Developer</a></li><li class="navelem"><a class="el" href="dir_0e1030ab80149b7e8d6dfd17946e9c40.html">XHXKit</a></li><li class="navelem"><a class="el" href="dir_c9ece41fcb3917ec137dcec44cd0055f.html">XHXKit</a></li><li class="navelem"><a class="el" href="dir_3a9521ad7c4429598be7e28fa39d3d14.html">Classes</a></li><li class="navelem"><a class="el" href="dir_3d2fc70918afca98e451004947d5894e.html">BMDragCellCollectionView</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">BMDragCellCollectionView.m</div>  </div>
</div><!--header-->
<div class="contents">
<a href="_b_m_drag_cell_collection_view_8m.html">浏览该文件的文档.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&nbsp;<span class="comment">//</span></div>
<div class="line"><a name="l00002"></a><span class="lineno">    2</span>&nbsp;<span class="comment">//  BMDragCellCollectionView.m</span></div>
<div class="line"><a name="l00003"></a><span class="lineno">    3</span>&nbsp;<span class="comment">//</span></div>
<div class="line"><a name="l00004"></a><span class="lineno">    4</span>&nbsp;<span class="comment">//  Copyright &copy; 2017年 https://github.com/asiosldh/BMDragCellCollectionViewSwift/ All rights reserved.</span></div>
<div class="line"><a name="l00005"></a><span class="lineno">    5</span>&nbsp;<span class="comment">//</span></div>
<div class="line"><a name="l00006"></a><span class="lineno">    6</span>&nbsp;<span class="comment">//  Permission is hereby granted, free of charge, to any person obtaining a copy</span></div>
<div class="line"><a name="l00007"></a><span class="lineno">    7</span>&nbsp;<span class="comment">//  of this software and associated documentation files (the &#34;Software&#34;), to deal</span></div>
<div class="line"><a name="l00008"></a><span class="lineno">    8</span>&nbsp;<span class="comment">//  in the Software without restriction, including without limitation the rights</span></div>
<div class="line"><a name="l00009"></a><span class="lineno">    9</span>&nbsp;<span class="comment">//  to use, copy, modify, merge, publish, distribute, sublicense, and/or sell</span></div>
<div class="line"><a name="l00010"></a><span class="lineno">   10</span>&nbsp;<span class="comment">//  copies of the Software, and to permit persons to whom the Software is</span></div>
<div class="line"><a name="l00011"></a><span class="lineno">   11</span>&nbsp;<span class="comment">//  furnished to do so, subject to the following conditions:</span></div>
<div class="line"><a name="l00012"></a><span class="lineno">   12</span>&nbsp;<span class="comment">//</span></div>
<div class="line"><a name="l00013"></a><span class="lineno">   13</span>&nbsp;<span class="comment">//  The above copyright notice and this permission notice shall be included in</span></div>
<div class="line"><a name="l00014"></a><span class="lineno">   14</span>&nbsp;<span class="comment">//  all copies or substantial portions of the Software.</span></div>
<div class="line"><a name="l00015"></a><span class="lineno">   15</span>&nbsp;<span class="comment">//</span></div>
<div class="line"><a name="l00016"></a><span class="lineno">   16</span>&nbsp;<span class="comment">//  THE SOFTWARE IS PROVIDED &#34;AS IS&#34;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span></div>
<div class="line"><a name="l00017"></a><span class="lineno">   17</span>&nbsp;<span class="comment">//  IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span></div>
<div class="line"><a name="l00018"></a><span class="lineno">   18</span>&nbsp;<span class="comment">//  FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span></div>
<div class="line"><a name="l00019"></a><span class="lineno">   19</span>&nbsp;<span class="comment">//  AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span></div>
<div class="line"><a name="l00020"></a><span class="lineno">   20</span>&nbsp;<span class="comment">//  LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span></div>
<div class="line"><a name="l00021"></a><span class="lineno">   21</span>&nbsp;<span class="comment">//  OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN</span></div>
<div class="line"><a name="l00022"></a><span class="lineno">   22</span>&nbsp;<span class="comment">//  THE SOFTWARE.</span></div>
<div class="line"><a name="l00023"></a><span class="lineno">   23</span>&nbsp;<span class="preprocessor">#import &#34;<a class="code" href="_b_m_drag_cell_collection_view_8h.html">BMDragCellCollectionView.h</a>&#34;</span></div>
<div class="line"><a name="l00024"></a><span class="lineno">   24</span>&nbsp; </div>
<div class="line"><a name="l00025"></a><span class="lineno">   25</span>&nbsp;<span class="preprocessor">#pragma mark - UICollectionView (BMDragCellCollectionViewRect)</span></div>
<div class="line"><a name="l00026"></a><span class="lineno">   26</span>&nbsp; </div>
<div class="line"><a name="l00027"></a><span class="lineno"><a class="line" href="category_u_i_collection_view_07_b_m_rect_08.html">   27</a></span>&nbsp;<span class="keyword">@implementation </span><a class="code" href="category_u_i_collection_view_07_b_m_rect_08.html">UICollectionView (BMRect)</a></div>
<div class="line"><a name="l00028"></a><span class="lineno">   28</span>&nbsp; </div>
<div class="line"><a name="l00029"></a><span class="lineno">   29</span>&nbsp;- (CGRect)bm_rectForSection:(NSInteger)section {</div>
<div class="line"><a name="l00030"></a><span class="lineno">   30</span>&nbsp;    NSInteger sectionNum = [<span class="keyword">self</span>.dataSource collectionView:self numberOfItemsInSection:section];</div>
<div class="line"><a name="l00031"></a><span class="lineno">   31</span>&nbsp;    <span class="keywordflow">if</span> (sectionNum &lt;= 0) {</div>
<div class="line"><a name="l00032"></a><span class="lineno">   32</span>&nbsp;        <span class="keywordflow">return</span> CGRectZero;</div>
<div class="line"><a name="l00033"></a><span class="lineno">   33</span>&nbsp;    }</div>
<div class="line"><a name="l00034"></a><span class="lineno">   34</span>&nbsp;    CGRect firstRect = [<span class="keyword">self</span> bm_rectForRowAtIndexPath:[NSIndexPath indexPathForItem:0 inSection:section]];</div>
<div class="line"><a name="l00035"></a><span class="lineno">   35</span>&nbsp;    CGRect lastRect = [<span class="keyword">self</span> bm_rectForRowAtIndexPath:[NSIndexPath indexPathForItem:sectionNum-1 inSection:section]];</div>
<div class="line"><a name="l00036"></a><span class="lineno">   36</span>&nbsp;    <span class="keywordflow">return</span> ((UICollectionViewFlowLayout *)<span class="keyword">self</span>.collectionViewLayout).scrollDirection == UICollectionViewScrollDirectionHorizontal ?</div>
<div class="line"><a name="l00037"></a><span class="lineno">   37</span>&nbsp;    CGRectMake(CGRectGetMinX(firstRect), 0, CGRectGetMaxX(lastRect) - CGRectGetMinX(firstRect), CGRectGetHeight(<span class="keyword">self</span>.frame)) :</div>
<div class="line"><a name="l00038"></a><span class="lineno">   38</span>&nbsp;    CGRectMake(0, CGRectGetMinY(firstRect), CGRectGetWidth(<span class="keyword">self</span>.frame), CGRectGetMaxY(lastRect) - CGRectGetMidY(firstRect));</div>
<div class="line"><a name="l00039"></a><span class="lineno">   39</span>&nbsp;}</div>
<div class="line"><a name="l00040"></a><span class="lineno">   40</span>&nbsp; </div>
<div class="line"><a name="l00041"></a><span class="lineno">   41</span>&nbsp;- (CGRect)bm_rectForRowAtIndexPath:(NSIndexPath *)indexPath {</div>
<div class="line"><a name="l00042"></a><span class="lineno">   42</span>&nbsp;    <span class="keywordflow">return</span> [<span class="keyword">self</span> layoutAttributesForItemAtIndexPath:indexPath].frame;</div>
<div class="line"><a name="l00043"></a><span class="lineno">   43</span>&nbsp;}</div>
<div class="line"><a name="l00044"></a><span class="lineno">   44</span>&nbsp; </div>
<div class="line"><a name="l00045"></a><span class="lineno">   45</span>&nbsp;<span class="keyword">@end</span></div>
<div class="line"><a name="l00046"></a><span class="lineno">   46</span>&nbsp; </div>
<div class="line"><a name="l00047"></a><span class="lineno"><a class="line" href="_b_m_drag_cell_collection_view_8m.html#a8a46e87c5be0ba4be083382f642a5fa5">   47</a></span>&nbsp;<span class="keyword">typedef</span> <a class="code" href="_b_m_drag_cell_collection_view_8m.html#a8a46e87c5be0ba4be083382f642a5fa5">NS_ENUM</a>(NSUInteger, BMDragCellCollectionViewScrollDirection) {</div>
<div class="line"><a name="l00048"></a><span class="lineno">   48</span>&nbsp;    BMDragCellCollectionViewScrollDirectionNone = 0,</div>
<div class="line"><a name="l00049"></a><span class="lineno">   49</span>&nbsp;    BMDragCellCollectionViewScrollDirectionLeft,</div>
<div class="line"><a name="l00050"></a><span class="lineno">   50</span>&nbsp;    BMDragCellCollectionViewScrollDirectionRight,</div>
<div class="line"><a name="l00051"></a><span class="lineno">   51</span>&nbsp;    BMDragCellCollectionViewScrollDirectionUp,</div>
<div class="line"><a name="l00052"></a><span class="lineno">   52</span>&nbsp;    BMDragCellCollectionViewScrollDirectionDown,</div>
<div class="line"><a name="l00053"></a><span class="lineno">   53</span>&nbsp;};</div>
<div class="line"><a name="l00054"></a><span class="lineno">   54</span>&nbsp; </div>
<div class="line"><a name="l00055"></a><span class="lineno"><a class="line" href="category_b_m_drag_cell_collection_view_07_08.html">   55</a></span>&nbsp;<span class="keyword">@interface </span><a class="code" href="interface_b_m_drag_cell_collection_view.html">BMDragCellCollectionView</a> ()</div>
<div class="line"><a name="l00056"></a><span class="lineno">   56</span>&nbsp; </div>
<div class="line"><a name="l00057"></a><span class="lineno"><a class="line" href="category_b_m_drag_cell_collection_view_07_08.html#ad25d6ae70c2e7010a5a09a27d3ca2994">   57</a></span>&nbsp;<span class="keyword">@property</span> (strong, nonatomic) UIView *snapedView;                        </div>
<div class="line"><a name="l00058"></a><span class="lineno"><a class="line" href="category_b_m_drag_cell_collection_view_07_08.html#adffb99cc351d1d58e7fa6837661116ae">   58</a></span>&nbsp;<span class="keyword">@property</span> (strong, nonatomic) UILongPressGestureRecognizer *longGesture; </div>
<div class="line"><a name="l00059"></a><span class="lineno"><a class="line" href="category_b_m_drag_cell_collection_view_07_08.html#ae0b276c46d0e7dc9c1dbe161f68ee067">   59</a></span>&nbsp;<span class="keyword">@property</span> (strong, nonatomic) CADisplayLink *edgeTimer;                  </div>
<div class="line"><a name="l00060"></a><span class="lineno"><a class="line" href="category_b_m_drag_cell_collection_view_07_08.html#aec345a92b7c7284e0deb2e5a39dc01b0">   60</a></span>&nbsp;<span class="keyword">@property</span> (strong, nonatomic) NSIndexPath *oldIndexPath;                 </div>
<div class="line"><a name="l00061"></a><span class="lineno"><a class="line" href="category_b_m_drag_cell_collection_view_07_08.html#a83f02fc709decf52fe8f8b36ab95d2fc">   61</a></span>&nbsp;<span class="keyword">@property</span> (strong, nonatomic) NSIndexPath *currentIndexPath;             </div>
<div class="line"><a name="l00062"></a><span class="lineno"><a class="line" href="category_b_m_drag_cell_collection_view_07_08.html#a251ad55420ac4ce26cb8856b1d40de52">   62</a></span>&nbsp;<span class="keyword">@property</span> (assign, nonatomic) CGPoint oldPoint;                          </div>
<div class="line"><a name="l00063"></a><span class="lineno"><a class="line" href="category_b_m_drag_cell_collection_view_07_08.html#ab6cdbfa0c03cea792759586b6f3fb107">   63</a></span>&nbsp;<span class="keyword">@property</span> (assign, nonatomic) CGPoint lastPoint;                         </div>
<div class="line"><a name="l00064"></a><span class="lineno"><a class="line" href="category_b_m_drag_cell_collection_view_07_08.html#af3dc37858f8f8313af526f13bc226a65">   64</a></span>&nbsp;<span class="keyword">@property</span> (assign, nonatomic) BOOL isEndDrag;                            </div>
<div class="line"><a name="l00065"></a><span class="lineno">   65</span>&nbsp; </div>
<div class="line"><a name="l00066"></a><span class="lineno">   66</span>&nbsp;<span class="keyword">@end</span></div>
<div class="line"><a name="l00067"></a><span class="lineno">   67</span>&nbsp; </div>
<div class="line"><a name="l00068"></a><span class="lineno">   68</span>&nbsp;<span class="keyword">@implementation </span><a class="code" href="interface_b_m_drag_cell_collection_view.html">BMDragCellCollectionView</a></div>
<div class="line"><a name="l00069"></a><span class="lineno">   69</span>&nbsp; </div>
<div class="line"><a name="l00070"></a><span class="lineno">   70</span>&nbsp;@dynamic <a class="code" href="interface_b_m_drag_cell_collection_view.html#a0d195d85fc67f302f75a56ea8fad37e2">delegate</a>, dataSource;</div>
<div class="line"><a name="l00071"></a><span class="lineno">   71</span>&nbsp; </div>
<div class="line"><a name="l00072"></a><span class="lineno">   72</span>&nbsp;- (instancetype)initWithFrame:(CGRect)frame collectionViewLayout:(UICollectionViewLayout *)layout {</div>
<div class="line"><a name="l00073"></a><span class="lineno">   73</span>&nbsp;    <span class="keywordflow">if</span> (<span class="keyword">self</span> = [super initWithFrame:frame collectionViewLayout:layout]) {</div>
<div class="line"><a name="l00074"></a><span class="lineno">   74</span>&nbsp;        [<span class="keyword">self</span> initConfiguration];</div>
<div class="line"><a name="l00075"></a><span class="lineno">   75</span>&nbsp;    }</div>
<div class="line"><a name="l00076"></a><span class="lineno">   76</span>&nbsp;    <span class="keywordflow">return</span> <span class="keyword">self</span>;</div>
<div class="line"><a name="l00077"></a><span class="lineno">   77</span>&nbsp;}</div>
<div class="line"><a name="l00078"></a><span class="lineno">   78</span>&nbsp; </div>
<div class="line"><a name="l00079"></a><span class="lineno">   79</span>&nbsp;- (instancetype)initWithCoder:(NSCoder *)aDecoder {</div>
<div class="line"><a name="l00080"></a><span class="lineno">   80</span>&nbsp;    <span class="keywordflow">if</span> (<span class="keyword">self</span> = [super initWithCoder:aDecoder]) {</div>
<div class="line"><a name="l00081"></a><span class="lineno">   81</span>&nbsp;        [<span class="keyword">self</span> initConfiguration];</div>
<div class="line"><a name="l00082"></a><span class="lineno">   82</span>&nbsp;    }</div>
<div class="line"><a name="l00083"></a><span class="lineno">   83</span>&nbsp;    <span class="keywordflow">return</span> <span class="keyword">self</span>;</div>
<div class="line"><a name="l00084"></a><span class="lineno">   84</span>&nbsp;}</div>
<div class="line"><a name="l00085"></a><span class="lineno">   85</span>&nbsp; </div>
<div class="line"><a name="l00086"></a><span class="lineno">   86</span>&nbsp;- (void)dealloc {</div>
<div class="line"><a name="l00087"></a><span class="lineno">   87</span>&nbsp;    [<span class="keyword">self</span> _stopEdgeTimer];</div>
<div class="line"><a name="l00088"></a><span class="lineno">   88</span>&nbsp;}</div>
<div class="line"><a name="l00089"></a><span class="lineno">   89</span>&nbsp; </div>
<div class="line"><a name="l00090"></a><span class="lineno">   90</span>&nbsp;<span class="preprocessor">#pragma mark - getters setters</span></div>
<div class="line"><a name="l00091"></a><span class="lineno">   91</span>&nbsp; </div>
<div class="line"><a name="l00092"></a><span class="lineno">   92</span>&nbsp;- (void)setCanDrag:(BOOL)canDrag {</div>
<div class="line"><a name="l00093"></a><span class="lineno">   93</span>&nbsp;    _canDrag = <a class="code" href="interface_b_m_drag_cell_collection_view.html#a8fb9e550e0d0a0cbf970605714345dd1">canDrag</a>;</div>
<div class="line"><a name="l00094"></a><span class="lineno">   94</span>&nbsp;    <span class="keyword">self</span>.longGesture.enabled = _canDrag;</div>
<div class="line"><a name="l00095"></a><span class="lineno">   95</span>&nbsp;}</div>
<div class="line"><a name="l00096"></a><span class="lineno">   96</span>&nbsp; </div>
<div class="line"><a name="l00097"></a><span class="lineno">   97</span>&nbsp;- (void)setMinimumPressDuration:(NSTimeInterval)minimumPressDuration {</div>
<div class="line"><a name="l00098"></a><span class="lineno">   98</span>&nbsp;    _minimumPressDuration = <a class="code" href="interface_b_m_drag_cell_collection_view.html#a45e8b0e914c7241c534f487fb2f677c3">minimumPressDuration</a>;</div>
<div class="line"><a name="l00099"></a><span class="lineno">   99</span>&nbsp;    <span class="keyword">self</span>.longGesture.minimumPressDuration = <a class="code" href="interface_b_m_drag_cell_collection_view.html#a45e8b0e914c7241c534f487fb2f677c3">minimumPressDuration</a>;</div>
<div class="line"><a name="l00100"></a><span class="lineno">  100</span>&nbsp;}</div>
<div class="line"><a name="l00101"></a><span class="lineno">  101</span>&nbsp; </div>
<div class="line"><a name="l00102"></a><span class="lineno">  102</span>&nbsp;- (void)setDragZoomScale:(CGFloat)dragZoomScale {</div>
<div class="line"><a name="l00103"></a><span class="lineno">  103</span>&nbsp;    <span class="keywordflow">if</span> (<a class="code" href="interface_b_m_drag_cell_collection_view.html#aa45e437c7d9d69c896b93edd9f91763f">dragZoomScale</a> &lt; 0) {</div>
<div class="line"><a name="l00104"></a><span class="lineno">  104</span>&nbsp;        <a class="code" href="interface_b_m_drag_cell_collection_view.html#aa45e437c7d9d69c896b93edd9f91763f">dragZoomScale</a> = 0.01;</div>
<div class="line"><a name="l00105"></a><span class="lineno">  105</span>&nbsp;    }</div>
<div class="line"><a name="l00106"></a><span class="lineno">  106</span>&nbsp;    _dragZoomScale = <a class="code" href="interface_b_m_drag_cell_collection_view.html#aa45e437c7d9d69c896b93edd9f91763f">dragZoomScale</a>;</div>
<div class="line"><a name="l00107"></a><span class="lineno">  107</span>&nbsp;}</div>
<div class="line"><a name="l00108"></a><span class="lineno">  108</span>&nbsp; </div>
<div class="line"><a name="l00109"></a><span class="lineno">  109</span>&nbsp;- (UILongPressGestureRecognizer *)longGesture {</div>
<div class="line"><a name="l00110"></a><span class="lineno">  110</span>&nbsp;    <span class="keywordflow">if</span> (!_longGesture) {</div>
<div class="line"><a name="l00111"></a><span class="lineno">  111</span>&nbsp;        _longGesture = [[UILongPressGestureRecognizer alloc] initWithTarget:self action:@selector(handlelongGesture:)];</div>
<div class="line"><a name="l00112"></a><span class="lineno">  112</span>&nbsp;        _longGesture.minimumPressDuration = _minimumPressDuration;</div>
<div class="line"><a name="l00113"></a><span class="lineno">  113</span>&nbsp;    }</div>
<div class="line"><a name="l00114"></a><span class="lineno">  114</span>&nbsp;    <span class="keywordflow">return</span> _longGesture;</div>
<div class="line"><a name="l00115"></a><span class="lineno">  115</span>&nbsp;}</div>
<div class="line"><a name="l00116"></a><span class="lineno">  116</span>&nbsp; </div>
<div class="line"><a name="l00117"></a><span class="lineno">  117</span>&nbsp;<span class="comment">// iOS 10 新特性 对UICollectionView做了优化，但是这里如果使用了会导致bug,重写此方法是为了外面的使用者无法修改其值</span></div>
<div class="line"><a name="l00118"></a><span class="lineno">  118</span>&nbsp;- (void)setPrefetchingEnabled:(BOOL)prefetchingEnabled {</div>
<div class="line"><a name="l00119"></a><span class="lineno">  119</span>&nbsp;}</div>
<div class="line"><a name="l00120"></a><span class="lineno">  120</span>&nbsp; </div>
<div class="line"><a name="l00121"></a><span class="lineno">  121</span>&nbsp;<span class="preprocessor">#pragma mark - 私有方法</span></div>
<div class="line"><a name="l00122"></a><span class="lineno">  122</span>&nbsp; </div>
<div class="line"><a name="l00123"></a><span class="lineno">  123</span>&nbsp;- (void)initConfiguration {</div>
<div class="line"><a name="l00124"></a><span class="lineno">  124</span>&nbsp;    _canDrag = YES;</div>
<div class="line"><a name="l00125"></a><span class="lineno">  125</span>&nbsp;    _minimumPressDuration = .5f;</div>
<div class="line"><a name="l00126"></a><span class="lineno">  126</span>&nbsp;    _dragZoomScale = 1.2f;</div>
<div class="line"><a name="l00127"></a><span class="lineno">  127</span>&nbsp;    _dragCellAlpha = 1.0;</div>
<div class="line"><a name="l00128"></a><span class="lineno">  128</span>&nbsp;    [<span class="keyword">self</span> addGestureRecognizer:self.longGesture];</div>
<div class="line"><a name="l00129"></a><span class="lineno">  129</span>&nbsp;    <span class="comment">// iOS 10 新特性 对UICollectionView做了优化，但是这里如果使用了会导致bug</span></div>
<div class="line"><a name="l00130"></a><span class="lineno">  130</span>&nbsp;    <span class="comment">// https://developer.apple.com/documentation/uikit/uicollectionview/1771771-prefetchingenabled</span></div>
<div class="line"><a name="l00131"></a><span class="lineno">  131</span>&nbsp;    <span class="comment">// https://sxgfxm.github.io/blog/2016/10/18/uicollectionview-ios10-new-features/</span></div>
<div class="line"><a name="l00132"></a><span class="lineno">  132</span>&nbsp;    <span class="keywordflow">if</span> ([[[UIDevice currentDevice] systemVersion] floatValue] &gt;= 10.0) {</div>
<div class="line"><a name="l00133"></a><span class="lineno">  133</span>&nbsp;        super.prefetchingEnabled = NO;</div>
<div class="line"><a name="l00134"></a><span class="lineno">  134</span>&nbsp;    }</div>
<div class="line"><a name="l00135"></a><span class="lineno">  135</span>&nbsp;}</div>
<div class="line"><a name="l00136"></a><span class="lineno">  136</span>&nbsp; </div>
<div class="line"><a name="l00137"></a><span class="lineno">  137</span>&nbsp;- (UICollectionViewCell *)dequeueReusableCellWithReuseIdentifier:(NSString *)identifier forIndexPath:(NSIndexPath *)indexPath {</div>
<div class="line"><a name="l00138"></a><span class="lineno">  138</span>&nbsp;    UICollectionViewCell *cell = [<span class="keyword">super</span> dequeueReusableCellWithReuseIdentifier:identifier forIndexPath:indexPath];</div>
<div class="line"><a name="l00139"></a><span class="lineno">  139</span>&nbsp;    <span class="comment">// 处理复用时的问题，为了保证显示的正确性</span></div>
<div class="line"><a name="l00140"></a><span class="lineno">  140</span>&nbsp;    <span class="keywordflow">if</span> (_isEndDrag) {</div>
<div class="line"><a name="l00141"></a><span class="lineno">  141</span>&nbsp;        cell.hidden = NO;</div>
<div class="line"><a name="l00142"></a><span class="lineno">  142</span>&nbsp;        <span class="keywordflow">return</span> cell;</div>
<div class="line"><a name="l00143"></a><span class="lineno">  143</span>&nbsp;    }</div>
<div class="line"><a name="l00144"></a><span class="lineno">  144</span>&nbsp;    cell.hidden = (<span class="keyword">self</span>.oldIndexPath &amp;&amp; <span class="keyword">self</span>.oldIndexPath.item == indexPath.item &amp;&amp; <span class="keyword">self</span>.oldIndexPath.section == indexPath.section);</div>
<div class="line"><a name="l00145"></a><span class="lineno">  145</span>&nbsp;    <span class="keywordflow">return</span> cell;</div>
<div class="line"><a name="l00146"></a><span class="lineno">  146</span>&nbsp;}</div>
<div class="line"><a name="l00147"></a><span class="lineno">  147</span>&nbsp; </div>
<div class="line"><a name="l00148"></a><span class="lineno">  148</span>&nbsp;- (NSIndexPath *)_getChangedIndexPath {</div>
<div class="line"><a name="l00149"></a><span class="lineno">  149</span>&nbsp;    __block NSIndexPath *index = nil;</div>
<div class="line"><a name="l00150"></a><span class="lineno">  150</span>&nbsp;    CGPoint point = [<span class="keyword">self</span>.longGesture locationInView:self];</div>
<div class="line"><a name="l00151"></a><span class="lineno">  151</span>&nbsp;    <span class="comment">// 遍历拖拽的Cell的中心点在哪一个Cell里</span></div>
<div class="line"><a name="l00152"></a><span class="lineno">  152</span>&nbsp;    [[<span class="keyword">self</span> visibleCells] enumerateObjectsUsingBlock:^(__kindof UICollectionViewCell * _Nonnull obj, NSUInteger idx, BOOL * _Nonnull stop) {</div>
<div class="line"><a name="l00153"></a><span class="lineno">  153</span>&nbsp;        if (CGRectContainsPoint(obj.frame, point)) {</div>
<div class="line"><a name="l00154"></a><span class="lineno">  154</span>&nbsp;            index = [<span class="keyword">self</span> indexPathForCell:obj];</div>
<div class="line"><a name="l00155"></a><span class="lineno">  155</span>&nbsp;            *stop = YES;</div>
<div class="line"><a name="l00156"></a><span class="lineno">  156</span>&nbsp;        }</div>
<div class="line"><a name="l00157"></a><span class="lineno">  157</span>&nbsp;    }];</div>
<div class="line"><a name="l00158"></a><span class="lineno">  158</span>&nbsp;    <span class="comment">// 找到而且不是当前的Cell就返回此 index</span></div>
<div class="line"><a name="l00159"></a><span class="lineno">  159</span>&nbsp;    <span class="keywordflow">if</span> (index) {</div>
<div class="line"><a name="l00160"></a><span class="lineno">  160</span>&nbsp;        <span class="keywordflow">if</span> ((index.item == <span class="keyword">self</span>.oldIndexPath.item) &amp;&amp; (index.row == <span class="keyword">self</span>.oldIndexPath.row)) {</div>
<div class="line"><a name="l00161"></a><span class="lineno">  161</span>&nbsp;            <span class="keywordflow">return</span> nil;</div>
<div class="line"><a name="l00162"></a><span class="lineno">  162</span>&nbsp;        }</div>
<div class="line"><a name="l00163"></a><span class="lineno">  163</span>&nbsp;        <span class="keywordflow">return</span> index;</div>
<div class="line"><a name="l00164"></a><span class="lineno">  164</span>&nbsp;    }</div>
<div class="line"><a name="l00165"></a><span class="lineno">  165</span>&nbsp; </div>
<div class="line"><a name="l00166"></a><span class="lineno">  166</span>&nbsp;    <span class="comment">// 获取最应该交换的Cell</span></div>
<div class="line"><a name="l00167"></a><span class="lineno">  167</span>&nbsp;    __block CGFloat width = MAXFLOAT;</div>
<div class="line"><a name="l00168"></a><span class="lineno">  168</span>&nbsp;    __weak typeof(<span class="keyword">self</span>) weakSelf = self;</div>
<div class="line"><a name="l00169"></a><span class="lineno">  169</span>&nbsp;    [[self visibleCells] enumerateObjectsUsingBlock:^(__kindof UICollectionViewCell * _Nonnull obj, NSUInteger idx, BOOL * _Nonnull stop) {</div>
<div class="line"><a name="l00170"></a><span class="lineno">  170</span>&nbsp;        <span class="keywordflow">if</span> (CGRectContainsPoint(obj.frame, point)) {</div>
<div class="line"><a name="l00171"></a><span class="lineno">  171</span>&nbsp;            index = [<span class="keyword">self</span> indexPathForCell:obj];</div>
<div class="line"><a name="l00172"></a><span class="lineno">  172</span>&nbsp;            *stop = YES;</div>
<div class="line"><a name="l00173"></a><span class="lineno">  173</span>&nbsp;        }</div>
<div class="line"><a name="l00174"></a><span class="lineno">  174</span>&nbsp;        __strong typeof(weakSelf) <span class="keyword">self</span> = weakSelf;</div>
<div class="line"><a name="l00175"></a><span class="lineno">  175</span>&nbsp;        CGPoint p1 = <span class="keyword">self</span>.snapedView.center;</div>
<div class="line"><a name="l00176"></a><span class="lineno">  176</span>&nbsp;        CGPoint p2 = obj.center;</div>
<div class="line"><a name="l00177"></a><span class="lineno">  177</span>&nbsp;        <span class="comment">// 计算距离</span></div>
<div class="line"><a name="l00178"></a><span class="lineno">  178</span>&nbsp;        CGFloat distance = sqrt(pow((p1.x - p2.x), 2) + pow((p1.y - p2.y), 2));</div>
<div class="line"><a name="l00179"></a><span class="lineno">  179</span>&nbsp;        <span class="keywordflow">if</span> (distance &lt; width) {</div>
<div class="line"><a name="l00180"></a><span class="lineno">  180</span>&nbsp;            width = distance;</div>
<div class="line"><a name="l00181"></a><span class="lineno">  181</span>&nbsp;            index = [<span class="keyword">self</span> indexPathForCell:obj];</div>
<div class="line"><a name="l00182"></a><span class="lineno">  182</span>&nbsp;        }</div>
<div class="line"><a name="l00183"></a><span class="lineno">  183</span>&nbsp;    }];</div>
<div class="line"><a name="l00184"></a><span class="lineno">  184</span>&nbsp;    <span class="keywordflow">if</span> (!index) {</div>
<div class="line"><a name="l00185"></a><span class="lineno">  185</span>&nbsp;        <span class="keywordflow">return</span> nil;</div>
<div class="line"><a name="l00186"></a><span class="lineno">  186</span>&nbsp;    }</div>
<div class="line"><a name="l00187"></a><span class="lineno">  187</span>&nbsp;    <span class="keywordflow">if</span> ((index.item == <span class="keyword">self</span>.oldIndexPath.item) &amp;&amp; (index.row == <span class="keyword">self</span>.oldIndexPath.row)) {</div>
<div class="line"><a name="l00188"></a><span class="lineno">  188</span>&nbsp;        <span class="comment">// 最近的就是隐藏的Cell时,return nil</span></div>
<div class="line"><a name="l00189"></a><span class="lineno">  189</span>&nbsp;        <span class="keywordflow">return</span> nil;</div>
<div class="line"><a name="l00190"></a><span class="lineno">  190</span>&nbsp;    }</div>
<div class="line"><a name="l00191"></a><span class="lineno">  191</span>&nbsp;    <span class="keywordflow">return</span> index;</div>
<div class="line"><a name="l00192"></a><span class="lineno">  192</span>&nbsp;}</div>
<div class="line"><a name="l00193"></a><span class="lineno">  193</span>&nbsp; </div>
<div class="line"><a name="l00194"></a><span class="lineno">  194</span>&nbsp;<span class="comment">// 处理临界点问题</span></div>
<div class="line"><a name="l00195"></a><span class="lineno">  195</span>&nbsp;- (BMDragCellCollectionViewScrollDirection)_setScrollDirection {</div>
<div class="line"><a name="l00196"></a><span class="lineno">  196</span>&nbsp;    <span class="keywordflow">if</span> (<span class="keyword">self</span>.bounds.size.height + <span class="keyword">self</span>.contentOffset.y - _snapedView.center.y &lt; _snapedView.bounds.size.height / 2 &amp;&amp; <span class="keyword">self</span>.bounds.size.height + <span class="keyword">self</span>.contentOffset.y &lt; <span class="keyword">self</span>.contentSize.height) {</div>
<div class="line"><a name="l00197"></a><span class="lineno">  197</span>&nbsp;        <span class="keywordflow">return</span> BMDragCellCollectionViewScrollDirectionDown;</div>
<div class="line"><a name="l00198"></a><span class="lineno">  198</span>&nbsp;    }</div>
<div class="line"><a name="l00199"></a><span class="lineno">  199</span>&nbsp;    <span class="keywordflow">if</span> (_snapedView.center.y - <span class="keyword">self</span>.contentOffset.y &lt; _snapedView.bounds.size.height / 2 &amp;&amp; <span class="keyword">self</span>.contentOffset.y &gt; 0) {</div>
<div class="line"><a name="l00200"></a><span class="lineno">  200</span>&nbsp;        <span class="keywordflow">return</span> BMDragCellCollectionViewScrollDirectionUp;</div>
<div class="line"><a name="l00201"></a><span class="lineno">  201</span>&nbsp;    }</div>
<div class="line"><a name="l00202"></a><span class="lineno">  202</span>&nbsp;    <span class="keywordflow">if</span> (<span class="keyword">self</span>.bounds.size.width + <span class="keyword">self</span>.contentOffset.x - _snapedView.center.x &lt; _snapedView.bounds.size.width / 2 &amp;&amp; <span class="keyword">self</span>.bounds.size.width + <span class="keyword">self</span>.contentOffset.x &lt; <span class="keyword">self</span>.contentSize.width) {</div>
<div class="line"><a name="l00203"></a><span class="lineno">  203</span>&nbsp;        <span class="keywordflow">return</span> BMDragCellCollectionViewScrollDirectionRight;</div>
<div class="line"><a name="l00204"></a><span class="lineno">  204</span>&nbsp;    }</div>
<div class="line"><a name="l00205"></a><span class="lineno">  205</span>&nbsp;    <span class="keywordflow">if</span> (_snapedView.center.x - <span class="keyword">self</span>.contentOffset.x &lt; _snapedView.bounds.size.width / 2 &amp;&amp; <span class="keyword">self</span>.contentOffset.x &gt; 0) {</div>
<div class="line"><a name="l00206"></a><span class="lineno">  206</span>&nbsp;        <span class="keywordflow">return</span> BMDragCellCollectionViewScrollDirectionLeft;</div>
<div class="line"><a name="l00207"></a><span class="lineno">  207</span>&nbsp;    }</div>
<div class="line"><a name="l00208"></a><span class="lineno">  208</span>&nbsp;    <span class="keywordflow">return</span> BMDragCellCollectionViewScrollDirectionNone;</div>
<div class="line"><a name="l00209"></a><span class="lineno">  209</span>&nbsp;}</div>
<div class="line"><a name="l00210"></a><span class="lineno">  210</span>&nbsp; </div>
<div class="line"><a name="l00211"></a><span class="lineno">  211</span>&nbsp;<span class="comment">// 处理UICollectionView数据源</span></div>
<div class="line"><a name="l00212"></a><span class="lineno">  212</span>&nbsp;- (void)_updateSourceData {</div>
<div class="line"><a name="l00213"></a><span class="lineno">  213</span>&nbsp;    <span class="keywordflow">if</span> (_oldIndexPath &amp;&amp; _currentIndexPath &amp;&amp; ![_oldIndexPath isEqual:_currentIndexPath]) {</div>
<div class="line"><a name="l00214"></a><span class="lineno">  214</span>&nbsp;        <span class="comment">// 移动cell</span></div>
<div class="line"><a name="l00215"></a><span class="lineno">  215</span>&nbsp;        [<span class="keyword">self</span>.delegate dragCellCollectionView:self willMoveCellFormIndexPath:_oldIndexPath toIndexPath:_currentIndexPath];</div>
<div class="line"><a name="l00216"></a><span class="lineno">  216</span>&nbsp;    } <span class="keywordflow">else</span> <span class="keywordflow">if</span> (_oldIndexPath) {</div>
<div class="line"><a name="l00217"></a><span class="lineno">  217</span>&nbsp;        <span class="comment">// 删除cell</span></div>
<div class="line"><a name="l00218"></a><span class="lineno">  218</span>&nbsp;        [<span class="keyword">self</span>.delegate dragCellCollectionView:self willDeleteCellAtIndexPath:_oldIndexPath];</div>
<div class="line"><a name="l00219"></a><span class="lineno">  219</span>&nbsp;    }</div>
<div class="line"><a name="l00220"></a><span class="lineno">  220</span>&nbsp;}</div>
<div class="line"><a name="l00221"></a><span class="lineno">  221</span>&nbsp; </div>
<div class="line"><a name="l00222"></a><span class="lineno">  222</span>&nbsp;- (void)_setEdgeTimer{</div>
<div class="line"><a name="l00223"></a><span class="lineno">  223</span>&nbsp;    <span class="keywordflow">if</span> (!_edgeTimer) {</div>
<div class="line"><a name="l00224"></a><span class="lineno">  224</span>&nbsp;        _edgeTimer = [CADisplayLink displayLinkWithTarget:self selector:@selector(_edgeScroll)];</div>
<div class="line"><a name="l00225"></a><span class="lineno">  225</span>&nbsp;        [_edgeTimer addToRunLoop:[NSRunLoop mainRunLoop] forMode:NSRunLoopCommonModes];</div>
<div class="line"><a name="l00226"></a><span class="lineno">  226</span>&nbsp;    }</div>
<div class="line"><a name="l00227"></a><span class="lineno">  227</span>&nbsp;}</div>
<div class="line"><a name="l00228"></a><span class="lineno">  228</span>&nbsp; </div>
<div class="line"><a name="l00229"></a><span class="lineno">  229</span>&nbsp;- (void)_stopEdgeTimer{</div>
<div class="line"><a name="l00230"></a><span class="lineno">  230</span>&nbsp;    <span class="keywordflow">if</span> (_edgeTimer) {</div>
<div class="line"><a name="l00231"></a><span class="lineno">  231</span>&nbsp;        [_edgeTimer invalidate];</div>
<div class="line"><a name="l00232"></a><span class="lineno">  232</span>&nbsp;        _edgeTimer = nil;</div>
<div class="line"><a name="l00233"></a><span class="lineno">  233</span>&nbsp;    }</div>
<div class="line"><a name="l00234"></a><span class="lineno">  234</span>&nbsp;}</div>
<div class="line"><a name="l00235"></a><span class="lineno">  235</span>&nbsp; </div>
<div class="line"><a name="l00236"></a><span class="lineno">  236</span>&nbsp;- (void)_edgeScroll {</div>
<div class="line"><a name="l00237"></a><span class="lineno">  237</span>&nbsp;    BMDragCellCollectionViewScrollDirection scrollDirection = [<span class="keyword">self</span> _setScrollDirection];</div>
<div class="line"><a name="l00238"></a><span class="lineno">  238</span>&nbsp;    <span class="keywordflow">switch</span> (scrollDirection) {</div>
<div class="line"><a name="l00239"></a><span class="lineno">  239</span>&nbsp;        <span class="keywordflow">case</span> BMDragCellCollectionViewScrollDirectionLeft:{</div>
<div class="line"><a name="l00240"></a><span class="lineno">  240</span>&nbsp;            <span class="comment">//这里的动画必须设为NO</span></div>
<div class="line"><a name="l00241"></a><span class="lineno">  241</span>&nbsp;            [<span class="keyword">self</span> setContentOffset:CGPointMake(self.contentOffset.x - 4, self.contentOffset.y) animated:NO];</div>
<div class="line"><a name="l00242"></a><span class="lineno">  242</span>&nbsp;            _snapedView.center = CGPointMake(_snapedView.center.x - 4, _snapedView.center.y);</div>
<div class="line"><a name="l00243"></a><span class="lineno">  243</span>&nbsp;            _lastPoint.x -= 4;</div>
<div class="line"><a name="l00244"></a><span class="lineno">  244</span>&nbsp;        }</div>
<div class="line"><a name="l00245"></a><span class="lineno">  245</span>&nbsp;            <span class="keywordflow">break</span>;</div>
<div class="line"><a name="l00246"></a><span class="lineno">  246</span>&nbsp;        <span class="keywordflow">case</span> BMDragCellCollectionViewScrollDirectionRight:{</div>
<div class="line"><a name="l00247"></a><span class="lineno">  247</span>&nbsp;            [<span class="keyword">self</span> setContentOffset:CGPointMake(self.contentOffset.x + 4, self.contentOffset.y) animated:NO];</div>
<div class="line"><a name="l00248"></a><span class="lineno">  248</span>&nbsp;            _snapedView.center = CGPointMake(_snapedView.center.x + 4, _snapedView.center.y);</div>
<div class="line"><a name="l00249"></a><span class="lineno">  249</span>&nbsp;            _lastPoint.x += 4;</div>
<div class="line"><a name="l00250"></a><span class="lineno">  250</span>&nbsp;        }</div>
<div class="line"><a name="l00251"></a><span class="lineno">  251</span>&nbsp;            <span class="keywordflow">break</span>;</div>
<div class="line"><a name="l00252"></a><span class="lineno">  252</span>&nbsp;        <span class="keywordflow">case</span> BMDragCellCollectionViewScrollDirectionUp:{</div>
<div class="line"><a name="l00253"></a><span class="lineno">  253</span>&nbsp;            [<span class="keyword">self</span> setContentOffset:CGPointMake(self.contentOffset.x, self.contentOffset.y - 4) animated:NO];</div>
<div class="line"><a name="l00254"></a><span class="lineno">  254</span>&nbsp;            _snapedView.center = CGPointMake(_snapedView.center.x, _snapedView.center.y - 4);</div>
<div class="line"><a name="l00255"></a><span class="lineno">  255</span>&nbsp;            _lastPoint.y -= 4;</div>
<div class="line"><a name="l00256"></a><span class="lineno">  256</span>&nbsp;        }</div>
<div class="line"><a name="l00257"></a><span class="lineno">  257</span>&nbsp;            <span class="keywordflow">break</span>;</div>
<div class="line"><a name="l00258"></a><span class="lineno">  258</span>&nbsp;        <span class="keywordflow">case</span> BMDragCellCollectionViewScrollDirectionDown:{</div>
<div class="line"><a name="l00259"></a><span class="lineno">  259</span>&nbsp;            [<span class="keyword">self</span> setContentOffset:CGPointMake(self.contentOffset.x, self.contentOffset.y + 4) animated:NO];</div>
<div class="line"><a name="l00260"></a><span class="lineno">  260</span>&nbsp;            _snapedView.center = CGPointMake(_snapedView.center.x, _snapedView.center.y + 4);</div>
<div class="line"><a name="l00261"></a><span class="lineno">  261</span>&nbsp;            _lastPoint.y += 4;</div>
<div class="line"><a name="l00262"></a><span class="lineno">  262</span>&nbsp;        }</div>
<div class="line"><a name="l00263"></a><span class="lineno">  263</span>&nbsp;            <span class="keywordflow">break</span>;</div>
<div class="line"><a name="l00264"></a><span class="lineno">  264</span>&nbsp;        <span class="keywordflow">default</span>:</div>
<div class="line"><a name="l00265"></a><span class="lineno">  265</span>&nbsp;            <span class="keywordflow">break</span>;</div>
<div class="line"><a name="l00266"></a><span class="lineno">  266</span>&nbsp;    }</div>
<div class="line"><a name="l00267"></a><span class="lineno">  267</span>&nbsp;    </div>
<div class="line"><a name="l00268"></a><span class="lineno">  268</span>&nbsp;    <span class="keywordflow">if</span> (scrollDirection == BMDragCellCollectionViewScrollDirectionNone) {</div>
<div class="line"><a name="l00269"></a><span class="lineno">  269</span>&nbsp;        <span class="keywordflow">return</span>;</div>
<div class="line"><a name="l00270"></a><span class="lineno">  270</span>&nbsp;    }</div>
<div class="line"><a name="l00271"></a><span class="lineno">  271</span>&nbsp; </div>
<div class="line"><a name="l00272"></a><span class="lineno">  272</span>&nbsp;    <span class="comment">// 如果Cell 拖拽到了边沿时</span></div>
<div class="line"><a name="l00273"></a><span class="lineno">  273</span>&nbsp;    <span class="comment">// 截图视图位置移动</span></div>
<div class="line"><a name="l00274"></a><span class="lineno">  274</span>&nbsp;    [UIView animateWithDuration:0.1 animations:^{</div>
<div class="line"><a name="l00275"></a><span class="lineno">  275</span>&nbsp;        _snapedView.center = _lastPoint;</div>
<div class="line"><a name="l00276"></a><span class="lineno">  276</span>&nbsp;    }];</div>
<div class="line"><a name="l00277"></a><span class="lineno">  277</span>&nbsp; </div>
<div class="line"><a name="l00278"></a><span class="lineno">  278</span>&nbsp;    <span class="comment">// 获取应该交换的Cell的位置</span></div>
<div class="line"><a name="l00279"></a><span class="lineno">  279</span>&nbsp;    NSIndexPath *index = [<span class="keyword">self</span> _getChangedIndexPath];</div>
<div class="line"><a name="l00280"></a><span class="lineno">  280</span>&nbsp; </div>
<div class="line"><a name="l00281"></a><span class="lineno">  281</span>&nbsp;    <span class="keywordflow">if</span> (<span class="keyword">self</span>.<a class="code" href="interface_b_m_drag_cell_collection_view.html#a0d195d85fc67f302f75a56ea8fad37e2">delegate</a> &amp;&amp; [<span class="keyword">self</span>.<a class="code" href="interface_b_m_drag_cell_collection_view.html#a0d195d85fc67f302f75a56ea8fad37e2">delegate</a> respondsToSelector:<span class="keyword">@selector</span>(dragCellCollectionView:changedDragAtPoint:indexPath:)]) {</div>
<div class="line"><a name="l00282"></a><span class="lineno">  282</span>&nbsp;        [<span class="keyword">self</span>.delegate dragCellCollectionView:self changedDragAtPoint:_lastPoint indexPath:index];</div>
<div class="line"><a name="l00283"></a><span class="lineno">  283</span>&nbsp;    }</div>
<div class="line"><a name="l00284"></a><span class="lineno">  284</span>&nbsp;    </div>
<div class="line"><a name="l00285"></a><span class="lineno">  285</span>&nbsp;    <span class="keywordflow">if</span> (!index) {</div>
<div class="line"><a name="l00286"></a><span class="lineno">  286</span>&nbsp;        <span class="keywordflow">return</span>;</div>
<div class="line"><a name="l00287"></a><span class="lineno">  287</span>&nbsp;    }</div>
<div class="line"><a name="l00288"></a><span class="lineno">  288</span>&nbsp;    </div>
<div class="line"><a name="l00289"></a><span class="lineno">  289</span>&nbsp;    <span class="comment">// 是否可以交换</span></div>
<div class="line"><a name="l00290"></a><span class="lineno">  290</span>&nbsp;    <span class="keywordflow">if</span> (<span class="keyword">self</span>.<a class="code" href="interface_b_m_drag_cell_collection_view.html#a0d195d85fc67f302f75a56ea8fad37e2">delegate</a> &amp;&amp; [<span class="keyword">self</span>.<a class="code" href="interface_b_m_drag_cell_collection_view.html#a0d195d85fc67f302f75a56ea8fad37e2">delegate</a> respondsToSelector:<span class="keyword">@selector</span>(dragCellCollectionViewShouldBeginExchange:sourceIndexPath:toIndexPath:)]) {</div>
<div class="line"><a name="l00291"></a><span class="lineno">  291</span>&nbsp;        <span class="keywordflow">if</span> (![<span class="keyword">self</span>.<a class="code" href="interface_b_m_drag_cell_collection_view.html#a0d195d85fc67f302f75a56ea8fad37e2">delegate</a> dragCellCollectionViewShouldBeginExchange:<span class="keyword">self</span> sourceIndexPath:_oldIndexPath toIndexPath:index]) {</div>
<div class="line"><a name="l00292"></a><span class="lineno">  292</span>&nbsp;            <span class="keywordflow">return</span>;</div>
<div class="line"><a name="l00293"></a><span class="lineno">  293</span>&nbsp;        }</div>
<div class="line"><a name="l00294"></a><span class="lineno">  294</span>&nbsp;    }</div>
<div class="line"><a name="l00295"></a><span class="lineno">  295</span>&nbsp;    _currentIndexPath = index;</div>
<div class="line"><a name="l00296"></a><span class="lineno">  296</span>&nbsp;    <span class="keyword">self</span>.oldPoint = [<span class="keyword">self</span> cellForItemAtIndexPath:_currentIndexPath].center;</div>
<div class="line"><a name="l00297"></a><span class="lineno">  297</span>&nbsp;    </div>
<div class="line"><a name="l00298"></a><span class="lineno">  298</span>&nbsp;    <span class="comment">// 更新数据源</span></div>
<div class="line"><a name="l00299"></a><span class="lineno">  299</span>&nbsp;    [<span class="keyword">self</span> _updateSourceData];</div>
<div class="line"><a name="l00300"></a><span class="lineno">  300</span>&nbsp; </div>
<div class="line"><a name="l00301"></a><span class="lineno">  301</span>&nbsp;    <span class="comment">// 设置移动后的起始indexPath</span></div>
<div class="line"><a name="l00302"></a><span class="lineno">  302</span>&nbsp;    _oldIndexPath = _currentIndexPath;</div>
<div class="line"><a name="l00303"></a><span class="lineno">  303</span>&nbsp; </div>
<div class="line"><a name="l00304"></a><span class="lineno">  304</span>&nbsp;    <span class="comment">// 为了防止在缓存池取出的Cell已隐藏,</span></div>
<div class="line"><a name="l00305"></a><span class="lineno">  305</span>&nbsp;    <span class="comment">// 以后可以优化</span></div>
<div class="line"><a name="l00306"></a><span class="lineno">  306</span>&nbsp;    [<span class="keyword">self</span> reloadItemsAtIndexPaths:@[_oldIndexPath]];</div>
<div class="line"><a name="l00307"></a><span class="lineno">  307</span>&nbsp;}</div>
<div class="line"><a name="l00308"></a><span class="lineno">  308</span>&nbsp; </div>
<div class="line"><a name="l00309"></a><span class="lineno">  309</span>&nbsp;<span class="preprocessor">#pragma mark - 事件响应</span></div>
<div class="line"><a name="l00310"></a><span class="lineno">  310</span>&nbsp; </div>
<div class="line"><a name="l00311"></a><span class="lineno">  311</span>&nbsp;- (void)handlelongGesture:(UILongPressGestureRecognizer *)longGesture {</div>
<div class="line"><a name="l00312"></a><span class="lineno">  312</span>&nbsp;    CGPoint point = [longGesture locationInView:self];</div>
<div class="line"><a name="l00313"></a><span class="lineno">  313</span>&nbsp;    NSIndexPath *indexPath = [<span class="keyword">self</span> indexPathForItemAtPoint:point];</div>
<div class="line"><a name="l00314"></a><span class="lineno">  314</span>&nbsp;    <span class="keywordflow">switch</span> (longGesture.state) {</div>
<div class="line"><a name="l00315"></a><span class="lineno">  315</span>&nbsp;        <span class="keywordflow">case</span> UIGestureRecognizerStateBegan: {</div>
<div class="line"><a name="l00316"></a><span class="lineno">  316</span>&nbsp;            <span class="keyword">self</span>.userInteractionEnabled = NO;</div>
<div class="line"><a name="l00317"></a><span class="lineno">  317</span>&nbsp;            <span class="keywordflow">if</span> (<span class="keyword">self</span>.<a class="code" href="interface_b_m_drag_cell_collection_view.html#a0d195d85fc67f302f75a56ea8fad37e2">delegate</a> &amp;&amp; [<span class="keyword">self</span>.<a class="code" href="interface_b_m_drag_cell_collection_view.html#a0d195d85fc67f302f75a56ea8fad37e2">delegate</a> respondsToSelector:<span class="keyword">@selector</span>(dragCellCollectionView:beganDragAtPoint:indexPath:)]) {</div>
<div class="line"><a name="l00318"></a><span class="lineno">  318</span>&nbsp;                [<span class="keyword">self</span>.delegate dragCellCollectionView:self beganDragAtPoint:point indexPath:indexPath];</div>
<div class="line"><a name="l00319"></a><span class="lineno">  319</span>&nbsp;            }</div>
<div class="line"><a name="l00320"></a><span class="lineno">  320</span>&nbsp;            </div>
<div class="line"><a name="l00321"></a><span class="lineno">  321</span>&nbsp;            <span class="comment">// 手势开始</span></div>
<div class="line"><a name="l00322"></a><span class="lineno">  322</span>&nbsp;            <span class="comment">// 判断手势落点位置是否在Item上</span></div>
<div class="line"><a name="l00323"></a><span class="lineno">  323</span>&nbsp;            _oldIndexPath = indexPath;</div>
<div class="line"><a name="l00324"></a><span class="lineno">  324</span>&nbsp;            </div>
<div class="line"><a name="l00325"></a><span class="lineno">  325</span>&nbsp;            <span class="comment">// 没有按在cell 上就 break</span></div>
<div class="line"><a name="l00326"></a><span class="lineno">  326</span>&nbsp;            <span class="keywordflow">if</span> (_oldIndexPath == nil) {</div>
<div class="line"><a name="l00327"></a><span class="lineno">  327</span>&nbsp;                <span class="keyword">self</span>.longGesture.enabled = NO;</div>
<div class="line"><a name="l00328"></a><span class="lineno">  328</span>&nbsp;                dispatch_after(dispatch_time(DISPATCH_TIME_NOW, (int64_t)(0.25 * NSEC_PER_SEC)), dispatch_get_main_queue(), ^{</div>
<div class="line"><a name="l00329"></a><span class="lineno">  329</span>&nbsp;                    <span class="keywordflow">if</span> (_canDrag) {</div>
<div class="line"><a name="l00330"></a><span class="lineno">  330</span>&nbsp;                        <span class="keyword">self</span>.longGesture.enabled = YES;</div>
<div class="line"><a name="l00331"></a><span class="lineno">  331</span>&nbsp;                    }</div>
<div class="line"><a name="l00332"></a><span class="lineno">  332</span>&nbsp;                });</div>
<div class="line"><a name="l00333"></a><span class="lineno">  333</span>&nbsp;                <span class="keywordflow">break</span>;</div>
<div class="line"><a name="l00334"></a><span class="lineno">  334</span>&nbsp;            }</div>
<div class="line"><a name="l00335"></a><span class="lineno">  335</span>&nbsp;            <span class="keywordflow">if</span> (<span class="keyword">self</span>.<a class="code" href="interface_b_m_drag_cell_collection_view.html#a0d195d85fc67f302f75a56ea8fad37e2">delegate</a> &amp;&amp; [<span class="keyword">self</span>.<a class="code" href="interface_b_m_drag_cell_collection_view.html#a0d195d85fc67f302f75a56ea8fad37e2">delegate</a> respondsToSelector:<span class="keyword">@selector</span>(dragCellCollectionViewShouldBeginMove:indexPath:)]) {</div>
<div class="line"><a name="l00336"></a><span class="lineno">  336</span>&nbsp;                <span class="keywordflow">if</span> (![<span class="keyword">self</span>.<a class="code" href="interface_b_m_drag_cell_collection_view.html#a0d195d85fc67f302f75a56ea8fad37e2">delegate</a> dragCellCollectionViewShouldBeginMove:<span class="keyword">self</span> indexPath:_oldIndexPath]) {</div>
<div class="line"><a name="l00337"></a><span class="lineno">  337</span>&nbsp;                    _oldIndexPath = nil;</div>
<div class="line"><a name="l00338"></a><span class="lineno">  338</span>&nbsp;                    <span class="keyword">self</span>.longGesture.enabled = NO;</div>
<div class="line"><a name="l00339"></a><span class="lineno">  339</span>&nbsp;                    dispatch_after(dispatch_time(DISPATCH_TIME_NOW, (int64_t)(0.25 * NSEC_PER_SEC)), dispatch_get_main_queue(), ^{</div>
<div class="line"><a name="l00340"></a><span class="lineno">  340</span>&nbsp;                        <span class="keywordflow">if</span> (_canDrag) {</div>
<div class="line"><a name="l00341"></a><span class="lineno">  341</span>&nbsp;                            <span class="keyword">self</span>.longGesture.enabled = YES;</div>
<div class="line"><a name="l00342"></a><span class="lineno">  342</span>&nbsp;                        }</div>
<div class="line"><a name="l00343"></a><span class="lineno">  343</span>&nbsp;                    });</div>
<div class="line"><a name="l00344"></a><span class="lineno">  344</span>&nbsp;                    <span class="keywordflow">break</span>;</div>
<div class="line"><a name="l00345"></a><span class="lineno">  345</span>&nbsp;                }</div>
<div class="line"><a name="l00346"></a><span class="lineno">  346</span>&nbsp;            }</div>
<div class="line"><a name="l00347"></a><span class="lineno">  347</span>&nbsp;            <span class="keyword">self</span>.isEndDrag = NO;</div>
<div class="line"><a name="l00348"></a><span class="lineno">  348</span>&nbsp;            <span class="comment">// 取出正在长按的cell</span></div>
<div class="line"><a name="l00349"></a><span class="lineno">  349</span>&nbsp;            UICollectionViewCell *cell = [<span class="keyword">self</span> cellForItemAtIndexPath:_oldIndexPath];</div>
<div class="line"><a name="l00350"></a><span class="lineno">  350</span>&nbsp;            <span class="keyword">self</span>.oldPoint = cell.center;</div>
<div class="line"><a name="l00351"></a><span class="lineno">  351</span>&nbsp;            </div>
<div class="line"><a name="l00352"></a><span class="lineno">  352</span>&nbsp;            <span class="comment">// 使用系统截图功能，得到cell的快照view</span></div>
<div class="line"><a name="l00353"></a><span class="lineno">  353</span>&nbsp;            _snapedView = [cell snapshotViewAfterScreenUpdates:NO];</div>
<div class="line"><a name="l00354"></a><span class="lineno">  354</span>&nbsp;            <span class="comment">// 设置frame</span></div>
<div class="line"><a name="l00355"></a><span class="lineno">  355</span>&nbsp;            _snapedView.frame = cell.frame;</div>
<div class="line"><a name="l00356"></a><span class="lineno">  356</span>&nbsp;            <span class="comment">// 添加到 collectionView 不然无法显示</span></div>
<div class="line"><a name="l00357"></a><span class="lineno">  357</span>&nbsp;            [<span class="keyword">self</span> addSubview:_snapedView];</div>
<div class="line"><a name="l00358"></a><span class="lineno">  358</span>&nbsp; </div>
<div class="line"><a name="l00359"></a><span class="lineno">  359</span>&nbsp;            <span class="comment">//截图后隐藏当前cell</span></div>
<div class="line"><a name="l00360"></a><span class="lineno">  360</span>&nbsp;            cell.hidden = YES;</div>
<div class="line"><a name="l00361"></a><span class="lineno">  361</span>&nbsp;            </div>
<div class="line"><a name="l00362"></a><span class="lineno">  362</span>&nbsp;            <span class="comment">// 获取当前触摸的中心点</span></div>
<div class="line"><a name="l00363"></a><span class="lineno">  363</span>&nbsp;            CGPoint currentPoint = point;</div>
<div class="line"><a name="l00364"></a><span class="lineno">  364</span>&nbsp;            </div>
<div class="line"><a name="l00365"></a><span class="lineno">  365</span>&nbsp;            <span class="comment">// 动画放大和移动到触摸点下面</span></div>
<div class="line"><a name="l00366"></a><span class="lineno">  366</span>&nbsp;            [UIView animateWithDuration:0.25 animations:^{</div>
<div class="line"><a name="l00367"></a><span class="lineno">  367</span>&nbsp;                _snapedView.transform = CGAffineTransformMakeScale(_dragZoomScale, _dragZoomScale);</div>
<div class="line"><a name="l00368"></a><span class="lineno">  368</span>&nbsp;                _snapedView.center = CGPointMake(currentPoint.x, currentPoint.y);</div>
<div class="line"><a name="l00369"></a><span class="lineno">  369</span>&nbsp;                _snapedView.alpha = _dragCellAlpha;</div>
<div class="line"><a name="l00370"></a><span class="lineno">  370</span>&nbsp;            }];</div>
<div class="line"><a name="l00371"></a><span class="lineno">  371</span>&nbsp;            <span class="comment">// 开启collectionView的边缘自动滚动检测</span></div>
<div class="line"><a name="l00372"></a><span class="lineno">  372</span>&nbsp;            [<span class="keyword">self</span> _setEdgeTimer];</div>
<div class="line"><a name="l00373"></a><span class="lineno">  373</span>&nbsp;        }</div>
<div class="line"><a name="l00374"></a><span class="lineno">  374</span>&nbsp;            <span class="keywordflow">break</span>;</div>
<div class="line"><a name="l00375"></a><span class="lineno">  375</span>&nbsp;        <span class="keywordflow">case</span> UIGestureRecognizerStateChanged: {</div>
<div class="line"><a name="l00376"></a><span class="lineno">  376</span>&nbsp; </div>
<div class="line"><a name="l00377"></a><span class="lineno">  377</span>&nbsp;            <span class="keywordflow">if</span> (<span class="keyword">self</span>.<a class="code" href="interface_b_m_drag_cell_collection_view.html#a0d195d85fc67f302f75a56ea8fad37e2">delegate</a> &amp;&amp; [<span class="keyword">self</span>.<a class="code" href="interface_b_m_drag_cell_collection_view.html#a0d195d85fc67f302f75a56ea8fad37e2">delegate</a> respondsToSelector:<span class="keyword">@selector</span>(dragCellCollectionView:changedDragAtPoint:indexPath:)]) {</div>
<div class="line"><a name="l00378"></a><span class="lineno">  378</span>&nbsp;                [<span class="keyword">self</span>.delegate dragCellCollectionView:self changedDragAtPoint:point indexPath:indexPath];</div>
<div class="line"><a name="l00379"></a><span class="lineno">  379</span>&nbsp;            }</div>
<div class="line"><a name="l00380"></a><span class="lineno">  380</span>&nbsp;            </div>
<div class="line"><a name="l00381"></a><span class="lineno">  381</span>&nbsp;            <span class="comment">// 当前手指位置</span></div>
<div class="line"><a name="l00382"></a><span class="lineno">  382</span>&nbsp;            _lastPoint = point;</div>
<div class="line"><a name="l00383"></a><span class="lineno">  383</span>&nbsp;            <span class="comment">// 截图视图位置移动</span></div>
<div class="line"><a name="l00384"></a><span class="lineno">  384</span>&nbsp;            [UIView animateWithDuration:0.1 animations:^{</div>
<div class="line"><a name="l00385"></a><span class="lineno">  385</span>&nbsp;                _snapedView.center = _lastPoint;</div>
<div class="line"><a name="l00386"></a><span class="lineno">  386</span>&nbsp;            }];</div>
<div class="line"><a name="l00387"></a><span class="lineno">  387</span>&nbsp;            </div>
<div class="line"><a name="l00388"></a><span class="lineno">  388</span>&nbsp;            NSIndexPath *index = [<span class="keyword">self</span> _getChangedIndexPath];</div>
<div class="line"><a name="l00389"></a><span class="lineno">  389</span>&nbsp;            </div>
<div class="line"><a name="l00390"></a><span class="lineno">  390</span>&nbsp;            <span class="comment">// 没有取到或者距离隐藏的最近时就返回</span></div>
<div class="line"><a name="l00391"></a><span class="lineno">  391</span>&nbsp;            <span class="keywordflow">if</span> (!index) {</div>
<div class="line"><a name="l00392"></a><span class="lineno">  392</span>&nbsp;                <span class="keywordflow">break</span>;</div>
<div class="line"><a name="l00393"></a><span class="lineno">  393</span>&nbsp;            }</div>
<div class="line"><a name="l00394"></a><span class="lineno">  394</span>&nbsp;            </div>
<div class="line"><a name="l00395"></a><span class="lineno">  395</span>&nbsp;            <span class="keywordflow">if</span> (<span class="keyword">self</span>.<a class="code" href="interface_b_m_drag_cell_collection_view.html#a0d195d85fc67f302f75a56ea8fad37e2">delegate</a> &amp;&amp; [<span class="keyword">self</span>.<a class="code" href="interface_b_m_drag_cell_collection_view.html#a0d195d85fc67f302f75a56ea8fad37e2">delegate</a> respondsToSelector:<span class="keyword">@selector</span>(dragCellCollectionViewShouldBeginExchange:sourceIndexPath:toIndexPath:)]) {</div>
<div class="line"><a name="l00396"></a><span class="lineno">  396</span>&nbsp;                <span class="keywordflow">if</span> (![<span class="keyword">self</span>.<a class="code" href="interface_b_m_drag_cell_collection_view.html#a0d195d85fc67f302f75a56ea8fad37e2">delegate</a> dragCellCollectionViewShouldBeginExchange:<span class="keyword">self</span> sourceIndexPath:_oldIndexPath toIndexPath:index]) {</div>
<div class="line"><a name="l00397"></a><span class="lineno">  397</span>&nbsp;                    <span class="keywordflow">break</span>;</div>
<div class="line"><a name="l00398"></a><span class="lineno">  398</span>&nbsp;                }</div>
<div class="line"><a name="l00399"></a><span class="lineno">  399</span>&nbsp;            }</div>
<div class="line"><a name="l00400"></a><span class="lineno">  400</span>&nbsp; </div>
<div class="line"><a name="l00401"></a><span class="lineno">  401</span>&nbsp;            _currentIndexPath = index;</div>
<div class="line"><a name="l00402"></a><span class="lineno">  402</span>&nbsp;            <span class="keyword">self</span>.oldPoint = [<span class="keyword">self</span> cellForItemAtIndexPath:_currentIndexPath].center;</div>
<div class="line"><a name="l00403"></a><span class="lineno">  403</span>&nbsp;            </div>
<div class="line"><a name="l00404"></a><span class="lineno">  404</span>&nbsp;            <span class="comment">// 操作</span></div>
<div class="line"><a name="l00405"></a><span class="lineno">  405</span>&nbsp;            [<span class="keyword">self</span> _updateSourceData];</div>
<div class="line"><a name="l00406"></a><span class="lineno">  406</span>&nbsp;            </div>
<div class="line"><a name="l00407"></a><span class="lineno">  407</span>&nbsp;            <span class="comment">// 设置移动后的起始indexPath</span></div>
<div class="line"><a name="l00408"></a><span class="lineno">  408</span>&nbsp;            _oldIndexPath = _currentIndexPath;</div>
<div class="line"><a name="l00409"></a><span class="lineno">  409</span>&nbsp;            [<span class="keyword">self</span> reloadItemsAtIndexPaths:@[_oldIndexPath]];</div>
<div class="line"><a name="l00410"></a><span class="lineno">  410</span>&nbsp;            <span class="keywordflow">break</span>;</div>
<div class="line"><a name="l00411"></a><span class="lineno">  411</span>&nbsp;        }</div>
<div class="line"><a name="l00412"></a><span class="lineno">  412</span>&nbsp;            <span class="keywordflow">break</span>;</div>
<div class="line"><a name="l00413"></a><span class="lineno">  413</span>&nbsp;        <span class="keywordflow">default</span>: {</div>
<div class="line"><a name="l00414"></a><span class="lineno">  414</span>&nbsp;            <span class="keyword">self</span>.userInteractionEnabled = YES;</div>
<div class="line"><a name="l00415"></a><span class="lineno">  415</span>&nbsp;            <span class="keywordflow">if</span> (<span class="keyword">self</span>.<a class="code" href="interface_b_m_drag_cell_collection_view.html#a0d195d85fc67f302f75a56ea8fad37e2">delegate</a> &amp;&amp; [<span class="keyword">self</span>.<a class="code" href="interface_b_m_drag_cell_collection_view.html#a0d195d85fc67f302f75a56ea8fad37e2">delegate</a> respondsToSelector:<span class="keyword">@selector</span>(dragCellCollectionView:endedDragAtPoint:indexPath:)]) {</div>
<div class="line"><a name="l00416"></a><span class="lineno">  416</span>&nbsp;                [<span class="keyword">self</span>.delegate dragCellCollectionView:self endedDragAtPoint:point indexPath:_currentIndexPath];</div>
<div class="line"><a name="l00417"></a><span class="lineno">  417</span>&nbsp;            }</div>
<div class="line"><a name="l00418"></a><span class="lineno">  418</span>&nbsp;            </div>
<div class="line"><a name="l00419"></a><span class="lineno">  419</span>&nbsp;            <span class="keywordflow">if</span> (longGesture.isEnabled) {</div>
<div class="line"><a name="l00420"></a><span class="lineno">  420</span>&nbsp;                <span class="keywordflow">if</span> (<span class="keyword">self</span>.<a class="code" href="interface_b_m_drag_cell_collection_view.html#a0d195d85fc67f302f75a56ea8fad37e2">delegate</a></div>
<div class="line"><a name="l00421"></a><span class="lineno">  421</span>&nbsp;                    &amp;&amp; [<span class="keyword">self</span>.<a class="code" href="interface_b_m_drag_cell_collection_view.html#a0d195d85fc67f302f75a56ea8fad37e2">delegate</a> respondsToSelector:<span class="keyword">@selector</span>(dragCellCollectionView:endedDragAutomaticOperationAtPoint:section:indexPath:)]) {</div>
<div class="line"><a name="l00422"></a><span class="lineno">  422</span>&nbsp;                    NSInteger section = -1;</div>
<div class="line"><a name="l00423"></a><span class="lineno">  423</span>&nbsp;                    NSInteger sec = [<span class="keyword">self</span>.dataSource numberOfSectionsInCollectionView:self];</div>
<div class="line"><a name="l00424"></a><span class="lineno">  424</span>&nbsp;                    <span class="keywordflow">for</span> (NSInteger i = 0; i &lt; sec; i++) {</div>
<div class="line"><a name="l00425"></a><span class="lineno">  425</span>&nbsp;                        <span class="keywordflow">if</span> (CGRectContainsPoint([<span class="keyword">self</span> bm_rectForSection:i], point)) {</div>
<div class="line"><a name="l00426"></a><span class="lineno">  426</span>&nbsp;                            section = i;</div>
<div class="line"><a name="l00427"></a><span class="lineno">  427</span>&nbsp;                            <span class="keywordflow">break</span>;</div>
<div class="line"><a name="l00428"></a><span class="lineno">  428</span>&nbsp;                        }</div>
<div class="line"><a name="l00429"></a><span class="lineno">  429</span>&nbsp;                    }</div>
<div class="line"><a name="l00430"></a><span class="lineno">  430</span>&nbsp;                    <span class="keywordflow">if</span> (![<span class="keyword">self</span>.<a class="code" href="interface_b_m_drag_cell_collection_view.html#a0d195d85fc67f302f75a56ea8fad37e2">delegate</a> dragCellCollectionView:<span class="keyword">self</span> endedDragAutomaticOperationAtPoint:point section:section indexPath:indexPath]) {</div>
<div class="line"><a name="l00431"></a><span class="lineno">  431</span>&nbsp;                        <span class="keywordflow">return</span>;</div>
<div class="line"><a name="l00432"></a><span class="lineno">  432</span>&nbsp;                    }</div>
<div class="line"><a name="l00433"></a><span class="lineno">  433</span>&nbsp;                }</div>
<div class="line"><a name="l00434"></a><span class="lineno">  434</span>&nbsp;                <span class="keywordflow">if</span> (!<span class="keyword">self</span>.oldIndexPath) {</div>
<div class="line"><a name="l00435"></a><span class="lineno">  435</span>&nbsp;                    <span class="keywordflow">return</span>;</div>
<div class="line"><a name="l00436"></a><span class="lineno">  436</span>&nbsp;                }</div>
<div class="line"><a name="l00437"></a><span class="lineno">  437</span>&nbsp;                </div>
<div class="line"><a name="l00438"></a><span class="lineno">  438</span>&nbsp;                UICollectionViewCell *cell = [<span class="keyword">self</span> cellForItemAtIndexPath:_oldIndexPath];</div>
<div class="line"><a name="l00439"></a><span class="lineno">  439</span>&nbsp;                </div>
<div class="line"><a name="l00440"></a><span class="lineno">  440</span>&nbsp;                <span class="comment">// 结束动画过程中停止交互，防止出问题</span></div>
<div class="line"><a name="l00441"></a><span class="lineno">  441</span>&nbsp;                <span class="keyword">self</span>.userInteractionEnabled = NO;</div>
<div class="line"><a name="l00442"></a><span class="lineno">  442</span>&nbsp;                <span class="comment">// 结束拖拽了</span></div>
<div class="line"><a name="l00443"></a><span class="lineno">  443</span>&nbsp;                <span class="keyword">self</span>.isEndDrag = YES;</div>
<div class="line"><a name="l00444"></a><span class="lineno">  444</span>&nbsp;                <span class="comment">// 给截图视图一个动画移动到隐藏cell的新位置</span></div>
<div class="line"><a name="l00445"></a><span class="lineno">  445</span>&nbsp;                [UIView animateWithDuration:0.25 animations:^{</div>
<div class="line"><a name="l00446"></a><span class="lineno">  446</span>&nbsp;                    if (!cell) {</div>
<div class="line"><a name="l00447"></a><span class="lineno">  447</span>&nbsp;                        _snapedView.center = _oldPoint;</div>
<div class="line"><a name="l00448"></a><span class="lineno">  448</span>&nbsp;                    } else {</div>
<div class="line"><a name="l00449"></a><span class="lineno">  449</span>&nbsp;                        _snapedView.center = cell.center;</div>
<div class="line"><a name="l00450"></a><span class="lineno">  450</span>&nbsp;                    }</div>
<div class="line"><a name="l00451"></a><span class="lineno">  451</span>&nbsp;                    _snapedView.transform = CGAffineTransformMakeScale(1.0f, 1.0f);</div>
<div class="line"><a name="l00452"></a><span class="lineno">  452</span>&nbsp;                    _snapedView.alpha = 1.0;</div>
<div class="line"><a name="l00453"></a><span class="lineno">  453</span>&nbsp;                } completion:^(BOOL finished) {</div>
<div class="line"><a name="l00454"></a><span class="lineno">  454</span>&nbsp;                    <span class="comment">// 移除截图视图、显示隐藏的cell并开启交互</span></div>
<div class="line"><a name="l00455"></a><span class="lineno">  455</span>&nbsp;                    [_snapedView removeFromSuperview];</div>
<div class="line"><a name="l00456"></a><span class="lineno">  456</span>&nbsp;                    cell.hidden = NO;</div>
<div class="line"><a name="l00457"></a><span class="lineno">  457</span>&nbsp;                    self.userInteractionEnabled = YES;</div>
<div class="line"><a name="l00458"></a><span class="lineno">  458</span>&nbsp;                    if (self.delegate &amp;&amp; [<span class="keyword">self</span>.delegate respondsToSelector:@selector(dragCellCollectionViewDidEndDrag:)]) {</div>
<div class="line"><a name="l00459"></a><span class="lineno">  459</span>&nbsp;                        [<span class="keyword">self</span>.delegate dragCellCollectionViewDidEndDrag:self];</div>
<div class="line"><a name="l00460"></a><span class="lineno">  460</span>&nbsp;                    }</div>
<div class="line"><a name="l00461"></a><span class="lineno">  461</span>&nbsp;                }];</div>
<div class="line"><a name="l00462"></a><span class="lineno">  462</span>&nbsp;            }</div>
<div class="line"><a name="l00463"></a><span class="lineno">  463</span>&nbsp;            <span class="comment">// 关闭定时器</span></div>
<div class="line"><a name="l00464"></a><span class="lineno">  464</span>&nbsp;            <span class="keyword">self</span>.oldIndexPath = nil;</div>
<div class="line"><a name="l00465"></a><span class="lineno">  465</span>&nbsp;            [<span class="keyword">self</span> _stopEdgeTimer];</div>
<div class="line"><a name="l00466"></a><span class="lineno">  466</span>&nbsp;        }</div>
<div class="line"><a name="l00467"></a><span class="lineno">  467</span>&nbsp;            <span class="keywordflow">break</span>;</div>
<div class="line"><a name="l00468"></a><span class="lineno">  468</span>&nbsp;    }</div>
<div class="line"><a name="l00469"></a><span class="lineno">  469</span>&nbsp;}</div>
<div class="line"><a name="l00470"></a><span class="lineno">  470</span>&nbsp; </div>
<div class="line"><a name="l00471"></a><span class="lineno">  471</span>&nbsp;- (void)dragMoveItemToIndexPath:(NSIndexPath *)newIndexPath {</div>
<div class="line"><a name="l00472"></a><span class="lineno">  472</span>&nbsp;    <span class="keywordflow">if</span> (<span class="keyword">self</span>.isEndDrag) {</div>
<div class="line"><a name="l00473"></a><span class="lineno">  473</span>&nbsp;        <span class="keywordflow">return</span>;</div>
<div class="line"><a name="l00474"></a><span class="lineno">  474</span>&nbsp;    }</div>
<div class="line"><a name="l00475"></a><span class="lineno">  475</span>&nbsp;    <span class="keyword">self</span>.isEndDrag = YES;</div>
<div class="line"><a name="l00476"></a><span class="lineno">  476</span>&nbsp;    <span class="keyword">self</span>.longGesture.enabled = NO;</div>
<div class="line"><a name="l00477"></a><span class="lineno">  477</span>&nbsp;    dispatch_after(dispatch_time(DISPATCH_TIME_NOW, (int64_t)(0.25 * NSEC_PER_SEC)), dispatch_get_main_queue(), ^{</div>
<div class="line"><a name="l00478"></a><span class="lineno">  478</span>&nbsp;        <span class="keywordflow">if</span> (_canDrag) {</div>
<div class="line"><a name="l00479"></a><span class="lineno">  479</span>&nbsp;            <span class="keyword">self</span>.longGesture.enabled = YES;</div>
<div class="line"><a name="l00480"></a><span class="lineno">  480</span>&nbsp;        }</div>
<div class="line"><a name="l00481"></a><span class="lineno">  481</span>&nbsp;    });</div>
<div class="line"><a name="l00482"></a><span class="lineno">  482</span>&nbsp;    _currentIndexPath = newIndexPath;</div>
<div class="line"><a name="l00483"></a><span class="lineno">  483</span>&nbsp;    </div>
<div class="line"><a name="l00484"></a><span class="lineno">  484</span>&nbsp;    <span class="comment">// 操作</span></div>
<div class="line"><a name="l00485"></a><span class="lineno">  485</span>&nbsp;    [<span class="keyword">self</span> _updateSourceData];</div>
<div class="line"><a name="l00486"></a><span class="lineno">  486</span>&nbsp;    <span class="comment">// 设置移动后的起始indexPath</span></div>
<div class="line"><a name="l00487"></a><span class="lineno">  487</span>&nbsp;    _oldIndexPath = newIndexPath;</div>
<div class="line"><a name="l00488"></a><span class="lineno">  488</span>&nbsp;    [<span class="keyword">self</span> reloadItemsAtIndexPaths:@[newIndexPath]];</div>
<div class="line"><a name="l00489"></a><span class="lineno">  489</span>&nbsp;    </div>
<div class="line"><a name="l00490"></a><span class="lineno">  490</span>&nbsp;    UICollectionViewCell *cell = [<span class="keyword">self</span> cellForItemAtIndexPath:_oldIndexPath];</div>
<div class="line"><a name="l00491"></a><span class="lineno">  491</span>&nbsp;    cell.hidden = YES;</div>
<div class="line"><a name="l00492"></a><span class="lineno">  492</span>&nbsp; </div>
<div class="line"><a name="l00493"></a><span class="lineno">  493</span>&nbsp;    <span class="comment">//结束动画过程中停止交互，防止出问题</span></div>
<div class="line"><a name="l00494"></a><span class="lineno">  494</span>&nbsp;    <span class="keyword">self</span>.userInteractionEnabled = NO;</div>
<div class="line"><a name="l00495"></a><span class="lineno">  495</span>&nbsp;    <span class="comment">// 结束拖拽了</span></div>
<div class="line"><a name="l00496"></a><span class="lineno">  496</span>&nbsp;    <span class="keyword">self</span>.isEndDrag = YES;</div>
<div class="line"><a name="l00497"></a><span class="lineno">  497</span>&nbsp;    <span class="comment">// 给截图视图一个动画移动到隐藏cell的新位置</span></div>
<div class="line"><a name="l00498"></a><span class="lineno">  498</span>&nbsp;    [UIView animateWithDuration:0.25 animations:^{</div>
<div class="line"><a name="l00499"></a><span class="lineno">  499</span>&nbsp;        if (!cell) {</div>
<div class="line"><a name="l00500"></a><span class="lineno">  500</span>&nbsp;            _snapedView.center = _oldPoint;</div>
<div class="line"><a name="l00501"></a><span class="lineno">  501</span>&nbsp;        } else {</div>
<div class="line"><a name="l00502"></a><span class="lineno">  502</span>&nbsp;            _snapedView.center = cell.center;</div>
<div class="line"><a name="l00503"></a><span class="lineno">  503</span>&nbsp;        }</div>
<div class="line"><a name="l00504"></a><span class="lineno">  504</span>&nbsp;        _snapedView.transform = CGAffineTransformMakeScale(1.0f, 1.0f);</div>
<div class="line"><a name="l00505"></a><span class="lineno">  505</span>&nbsp;        _snapedView.alpha = 1.0;</div>
<div class="line"><a name="l00506"></a><span class="lineno">  506</span>&nbsp;    } completion:^(BOOL finished) {</div>
<div class="line"><a name="l00507"></a><span class="lineno">  507</span>&nbsp;        <span class="comment">// 移除截图视图、显示隐藏的cell并开启交互</span></div>
<div class="line"><a name="l00508"></a><span class="lineno">  508</span>&nbsp;        [_snapedView removeFromSuperview];</div>
<div class="line"><a name="l00509"></a><span class="lineno">  509</span>&nbsp;        cell.hidden = NO;</div>
<div class="line"><a name="l00510"></a><span class="lineno">  510</span>&nbsp;        self.userInteractionEnabled = YES;</div>
<div class="line"><a name="l00511"></a><span class="lineno">  511</span>&nbsp;        if (self.delegate &amp;&amp; [<span class="keyword">self</span>.delegate respondsToSelector:@selector(dragCellCollectionViewDidEndDrag:)]) {</div>
<div class="line"><a name="l00512"></a><span class="lineno">  512</span>&nbsp;            [<span class="keyword">self</span>.delegate dragCellCollectionViewDidEndDrag:self];</div>
<div class="line"><a name="l00513"></a><span class="lineno">  513</span>&nbsp;        }</div>
<div class="line"><a name="l00514"></a><span class="lineno">  514</span>&nbsp;    }];</div>
<div class="line"><a name="l00515"></a><span class="lineno">  515</span>&nbsp;    <span class="comment">// 关闭定时器</span></div>
<div class="line"><a name="l00516"></a><span class="lineno">  516</span>&nbsp;    _oldIndexPath = nil;</div>
<div class="line"><a name="l00517"></a><span class="lineno">  517</span>&nbsp;    [<span class="keyword">self</span> _stopEdgeTimer];</div>
<div class="line"><a name="l00518"></a><span class="lineno">  518</span>&nbsp;}</div>
<div class="line"><a name="l00519"></a><span class="lineno">  519</span>&nbsp; </div>
<div class="line"><a name="l00520"></a><span class="lineno">  520</span>&nbsp;- (void)<a class="code" href="interface_b_m_drag_cell_collection_view.html#a2bb07034e462b25ec32afe2f66e33cdf">deleteDraggingItem</a> {</div>
<div class="line"><a name="l00521"></a><span class="lineno">  521</span>&nbsp;    <span class="keywordflow">if</span> (<span class="keyword">self</span>.isEndDrag || !_oldIndexPath) {</div>
<div class="line"><a name="l00522"></a><span class="lineno">  522</span>&nbsp;        <span class="keywordflow">return</span>;</div>
<div class="line"><a name="l00523"></a><span class="lineno">  523</span>&nbsp;    }</div>
<div class="line"><a name="l00524"></a><span class="lineno">  524</span>&nbsp;    <span class="keyword">self</span>.longGesture.enabled = NO;</div>
<div class="line"><a name="l00525"></a><span class="lineno">  525</span>&nbsp;    _currentIndexPath = nil;</div>
<div class="line"><a name="l00526"></a><span class="lineno">  526</span>&nbsp;    [<span class="keyword">self</span> _updateSourceData];</div>
<div class="line"><a name="l00527"></a><span class="lineno">  527</span>&nbsp;    _oldIndexPath = nil;</div>
<div class="line"><a name="l00528"></a><span class="lineno">  528</span>&nbsp;    [<span class="keyword">self</span> _stopEdgeTimer];</div>
<div class="line"><a name="l00529"></a><span class="lineno">  529</span>&nbsp;    <span class="comment">// 开始动画</span></div>
<div class="line"><a name="l00530"></a><span class="lineno">  530</span>&nbsp;    [UIView animateWithDuration:0.25 delay:0 options:UIViewAnimationOptionCurveEaseInOut animations:^{</div>
<div class="line"><a name="l00531"></a><span class="lineno">  531</span>&nbsp;        <span class="keyword">self</span>.snapedView.alpha = 1;</div>
<div class="line"><a name="l00532"></a><span class="lineno">  532</span>&nbsp;    } completion:^(BOOL finished) {</div>
<div class="line"><a name="l00533"></a><span class="lineno">  533</span>&nbsp;        [<span class="keyword">self</span>.snapedView removeFromSuperview];</div>
<div class="line"><a name="l00534"></a><span class="lineno">  534</span>&nbsp;        self.isEndDrag = YES;</div>
<div class="line"><a name="l00535"></a><span class="lineno">  535</span>&nbsp;        self.userInteractionEnabled = YES;</div>
<div class="line"><a name="l00536"></a><span class="lineno">  536</span>&nbsp;        self.longGesture.enabled = YES;</div>
<div class="line"><a name="l00537"></a><span class="lineno">  537</span>&nbsp;        if (self.delegate &amp;&amp; [<span class="keyword">self</span>.delegate respondsToSelector:@selector(dragCellCollectionViewDidEndDrag:)]) {</div>
<div class="line"><a name="l00538"></a><span class="lineno">  538</span>&nbsp;            [<span class="keyword">self</span>.delegate dragCellCollectionViewDidEndDrag:self];</div>
<div class="line"><a name="l00539"></a><span class="lineno">  539</span>&nbsp;        }</div>
<div class="line"><a name="l00540"></a><span class="lineno">  540</span>&nbsp;    }];</div>
<div class="line"><a name="l00541"></a><span class="lineno">  541</span>&nbsp;}</div>
<div class="line"><a name="l00542"></a><span class="lineno">  542</span>&nbsp; </div>
<div class="line"><a name="l00543"></a><span class="lineno">  543</span>&nbsp;<span class="keyword">@end</span></div>
</div><!-- fragment --></div><!-- contents -->
<div class="ttc" id="a_b_m_drag_cell_collection_view_8m_html_a8a46e87c5be0ba4be083382f642a5fa5"><div class="ttname"><a href="_b_m_drag_cell_collection_view_8m.html#a8a46e87c5be0ba4be083382f642a5fa5">NS_ENUM</a></div><div class="ttdeci">typedef NS_ENUM(NSUInteger, BMDragCellCollectionViewScrollDirection)</div><div class="ttdef"><b>Definition:</b> <a href="_b_m_drag_cell_collection_view_8m_source.html#l00047">BMDragCellCollectionView.m:47</a></div></div>
<div class="ttc" id="ainterface_b_m_drag_cell_collection_view_html"><div class="ttname"><a href="interface_b_m_drag_cell_collection_view.html">BMDragCellCollectionView</a></div><div class="ttdef"><b>Definition:</b> <a href="_b_m_drag_cell_collection_view_8h_source.html#l00162">BMDragCellCollectionView.h:163</a></div></div>
<div class="ttc" id="ainterface_b_m_drag_cell_collection_view_html_a2bb07034e462b25ec32afe2f66e33cdf"><div class="ttname"><a href="interface_b_m_drag_cell_collection_view.html#a2bb07034e462b25ec32afe2f66e33cdf">-[BMDragCellCollectionView deleteDraggingItem]</a></div><div class="ttdeci">void deleteDraggingItem()</div><div class="ttdef"><b>Definition:</b> <a href="_b_m_drag_cell_collection_view_8m_source.html#l00064">BMDragCellCollectionView.m:520</a></div></div>
<div class="ttc" id="ainterface_b_m_drag_cell_collection_view_html_a0d195d85fc67f302f75a56ea8fad37e2"><div class="ttname"><a href="interface_b_m_drag_cell_collection_view.html#a0d195d85fc67f302f75a56ea8fad37e2">BMDragCellCollectionView::delegate</a></div><div class="ttdeci">id&lt; BMDragCellCollectionViewDelegate &gt; delegate</div><div class="ttdoc">代理 delegate</div><div class="ttdef"><b>Definition:</b> <a href="_b_m_drag_cell_collection_view_8h_source.html#l00164">BMDragCellCollectionView.h:164</a></div></div>
<div class="ttc" id="a_b_m_drag_cell_collection_view_8h_html"><div class="ttname"><a href="_b_m_drag_cell_collection_view_8h.html">BMDragCellCollectionView.h</a></div></div>
<div class="ttc" id="ainterface_b_m_drag_cell_collection_view_html_a8fb9e550e0d0a0cbf970605714345dd1"><div class="ttname"><a href="interface_b_m_drag_cell_collection_view.html#a8fb9e550e0d0a0cbf970605714345dd1">BMDragCellCollectionView::canDrag</a></div><div class="ttdeci">BOOL canDrag</div><div class="ttdef"><b>Definition:</b> <a href="_b_m_drag_cell_collection_view_8h_source.html#l00178">BMDragCellCollectionView.h:178</a></div></div>
<div class="ttc" id="ainterface_b_m_drag_cell_collection_view_html_aa45e437c7d9d69c896b93edd9f91763f"><div class="ttname"><a href="interface_b_m_drag_cell_collection_view.html#aa45e437c7d9d69c896b93edd9f91763f">BMDragCellCollectionView::dragZoomScale</a></div><div class="ttdeci">CGFloat dragZoomScale</div><div class="ttdef"><b>Definition:</b> <a href="_b_m_drag_cell_collection_view_8h_source.html#l00184">BMDragCellCollectionView.h:184</a></div></div>
<div class="ttc" id="ainterface_b_m_drag_cell_collection_view_html_a45e8b0e914c7241c534f487fb2f677c3"><div class="ttname"><a href="interface_b_m_drag_cell_collection_view.html#a45e8b0e914c7241c534f487fb2f677c3">BMDragCellCollectionView::minimumPressDuration</a></div><div class="ttdeci">NSTimeInterval minimumPressDuration</div><div class="ttdef"><b>Definition:</b> <a href="_b_m_drag_cell_collection_view_8h_source.html#l00170">BMDragCellCollectionView.h:170</a></div></div>
<div class="ttc" id="acategory_u_i_collection_view_07_b_m_rect_08_html"><div class="ttname"><a href="category_u_i_collection_view_07_b_m_rect_08.html">UICollectionView(BMRect)</a></div><div class="ttdef"><b>Definition:</b> <a href="_b_m_drag_cell_collection_view_8m_source.html#l00027">BMDragCellCollectionView.m:27</a></div></div>
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
制作者&nbsp;<a href="http://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.8.20
</small></address>


</body></html>